# Hurricane Documentation

# Hurricane Design Viewer

Public Member Functions | List of all members
Hurricane::CellViewer Class Reference

A simple top level window embedding the CellWidget. More...

Inherits QMainWindow.

## Public Member Functions

| CellViewer (QWidget *parent=NULL)
virtual | ~CellViewer ()
bool | isToolInterrupted () const
void | setEnableRedrawInterrupt (bool)
void | setApplicationName (const QString &)
Cell * | getCell () const
virtual void | setCell (Cell *)
void | renameCell (const char *)
virtual Cell * | getCellFromDb (const char *)
CellWidget * | getCellWidget ()
const CellWidget * | getCellWidget () const
ControllerWidget * | getControllerWidget ()
void | setAnonNetSelectable (bool)
void | select (Occurrence &)
void | unselect (Occurrence &)
void | unselectAll ()
void | setLayerVisible (const Name &layer, bool visible)

## Detailed Description

A simple top level window embedding the CellWidget.

This classe group together a CellWidget to view layout and a ControllerWidget that enables to control it. It should be used as the base for complete viewer.

## Constructor & Destructor Documentation

## ◆ CellViewer()

Hurricane::CellViewer::CellViewer | ( | QWidget * | parent = `NULL` | ) |

Construct a CellView window no Cell is actually loaded.

## ◆ ~CellViewer()

Hurricane::CellViewer::~CellViewer | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## ◆ isToolInterrupted()

bool Hurricane::CellViewer::isToolInterrupted | ( |  | ) | const

inline

Returns: true if the viewer has received an interruption request, in that case it will abort it's current redrawing pass (if any) and process the next drawing request.

## ◆ setEnableRedrawInterrupt()

void Hurricane::CellViewer::setEnableRedrawInterrupt | ( | bool | state | ) |

inline

Allows/disallow the redrawing interruptions. If disabled, the viewer will not abort it's drawing passes.

## ◆ setApplicationName()

void Hurricane::CellViewer::setApplicationName | ( | const QString & | name | ) |

inline

Sets the Qt application name. The name under which the application will appears for window managers.

## ◆ getCell()

Cell * Hurricane::CellViewer::getCell | ( |  | ) | const

Returns: The Cell currently viewer (may be `NULL` if there is none).

## ◆ setCell()

void Hurricane::CellViewer::setCell | ( | Cell * | cell | ) |

virtual

Load `cell` into the viewer.

## ◆ renameCell()

void Hurricane::CellViewer::renameCell | ( | const char * | name | ) |

Change the name of the currently loaded Cell.

## ◆ getCellFromDb()

Cell * Hurricane::CellViewer::getCellFromDb | ( | const char * | name | ) |

virtual

Returns: Load through a framework the Cell `name`.

Important: This function is virtual and actually empty. It is a placeholder
  for derived classes. It has not be made pure virtual as not every derived classes needs it. Instead it display a warning message.

## ◆ getCellWidget() [1/2]

CellWidget * Hurricane::CellViewer::getCellWidget | ( |  | ) |

inline

Returns: The associated CellWidget (the actual widget that do the display).

## ◆ getCellWidget() [2/2]

const CellWidget * Hurricane::CellViewer::getCellWidget | ( |  | ) | const

inline

Returns: The associated CellWidget (the actual widget that do the display). This is the const flavor.

## ◆ getControllerWidget()

ControllerWidget * Hurricane::CellViewer::getControllerWidget | ( |  | ) |

inline

Returns: The associated ControllerWidget.

## ◆ setAnonNetSelectable()

void Hurricane::CellViewer::setAnonNetSelectable | ( | bool | state | ) |

Allows/disallow the selection of anonymous nets whith the selection menu.

## ◆ select()

void Hurricane::CellViewer::select | ( | Occurrence & | occurrence | ) |

Add `occurrence` the set of selected occurrences. Also switch the viewer in selection mode (if not already on).

## ◆ unselect()

void Hurricane::CellViewer::unselect | ( | Occurrence & | occurrence | ) |

Whidraw `occurrence` from the set of selected occurrences.

## ◆ unselectAll()

void Hurricane::CellViewer::unselectAll | ( |  | ) |

Clear the whole set of selected occurrences.

## ◆ setLayerVisible()

void Hurricane::CellViewer::setLayerVisible | ( | const Name & | layer,
|  | bool | visible
| ) |  |

inline

Sets the visibility state of `layer`. This is the programatic equivalent of the ControllerWidget.

The documentation for this class was generated from the following files:

- CellViewer.h
- CellViewer.dox